#!/bin/bash

CMDP=$(pwd)
DIALOG="lxdialog"

MYPATH=/usr/local/src
PKGDIR=$MYPATH/packages/plugins
PLGDIR=$MYPATH/VDR/PLUGINS/src
PLGLIB=$MYPATH/VDR/PLUGINS/lib

VDRVERSION=$(grep 'VERSION' $MYPATH/VDR/config.h | cut -f 2 -d '"')

function Geometry ()
{
  ROWS=${1:-24} COLS=${2:-78}

  [ $ROWS = 0 ] && ROWS=24
  [ $COLS = 0 ] && COLS=78

  if [ $ROWS -lt 19 -o $COLS -lt 78 ]
  then
	echo "Your display is too small to run this script!"
	exit 1
  fi

  ROWS=$((ROWS-2)) COLS=$((COLS-2))
}

function RunPluginsMgr ()
{
 >/tmp/plugins.lst

function PluginVDRCheck ()
{
  if [ -d $MYPATH/VDR -o -h $MYPATH/VDR ]
  then
	cd $PLGDIR && sys=`ls -A`

	idx=1; GDidx=1

	for x in $sys
	do
		if [ -d "$x" -a ! -h "$x" ]
		then
			PLUGINCOUNTER=$PLUGINCOUNTER" $idx "

			for y in $sys
			do
				SLINK="---"

				if [ -d "$y" -a -h "$y" ]
				then
					d=$(ls -Ao "$y" | sed -e "s/.* $y -> //" -e "s#/##")
					if [ "$d" == "$x" ]
					then
						SLINK="$y"
						break
					else
						SLINK="---"
					fi
				fi
			done

			echo "P$idx='$SLINK $x -------'">> /tmp/plugins.lst

			idx=`expr $idx + 1`
		fi

		echo "XXX" ;echo $GDidx;echo "XXX";let GDidx=$GDidx+1
	done
  fi

  . /tmp/plugins.lst

  cd $PKGDIR; rm -rf *.tar; ls *> /tmp/tmp5.$$

  PLUGINCOUNTER2=$PLUGINCOUNTER

  pidx=$idx

  cd $PKGDIR

  for x in $(cat /tmp/tmp5.$$)
  do
	PACKAGE_SUFFIX=${x##*\.}
	case $PACKAGE_SUFFIX in
		(gz|GZ|tgz|TGZ) ORG_DIR=$(tar -tvzf $x | awk '{print $6}' | head -1)
				ORG_DIR=${ORG_DIR%%/*}
				;;
		(bz2)		bunzip2 -k $x
				PACKAGE_NAME=${x%.bz2}
				ORG_DIR=$(tar -tvf $PACKAGE_NAME | awk '{print $6}' | head -1)
				ORG_DIR=${ORG_DIR%%/*}
  esac

  LINKNAME=`echo "$ORG_DIR" | awk -F - '{print $1}'`

  for isplug in $PLUGINCOUNTER2 99
  do
	eval xx="$`echo P$isplug`"

	if [ ! "$xx" == "" ]
	then
		checkinstallplugin $LINKNAME P$isplug $xx
		if [ ! "$PSETnew" == "" ]
		then
			break
		fi
        fi
  done

  if [ ! "$PSETnew" == "" ]
  then
	echo "$PSETnew">> /tmp/plugins.lst
  else
	echo "P$pidx='$LINKNAME ------- $xx $ORG_DIR $x'">> /tmp/plugins.lst
  fi

  echo "XXX"; echo $GDidx;echo "XXX"; let GDidy=$GDidy+1

  if [ $GDidy == 3 ]
  then
	GDidy=0
	let GDidx=$GDidx+1
  fi

  PLUGINCOUNTER=$PLUGINCOUNTER" $pidx "

  pidx=`expr $pidx + 1`

  done

  echo "PLUGINCOUNTER=\"$PLUGINCOUNTER\"">> /tmp/plugins.lst
  echo "XXX" ;echo 100;echo "XXX"
}

function checkinstallplugin ()
{
  if [ "$1" == "$ORG_DIR" ]
  then  
	if [ "$4" == "$ORG_DIR" ]
	then
		PSETnew="$2='$3 $4 $ORG_DIR $x '"
	else
		PSETnew=""
	fi
  elif [ $1 == $3 ]
  then
	PSETnew="$2='$3 $4 $ORG_DIR $x '"
  else
	PSETnew=""
  fi
}

function menu_name ()
{
  echo -ne "$DIALOG --menu 'What to ?    */VDR/PUGINS/src        */packages/plugins    ' $ROWS $COLS $((ROWS-7)) '$default' \
  "> /tmp/MCmenu
  > /tmp/MCradiolists
}

function comment ()
{
  comment_ctr=$[ comment_ctr + 1 ]
}

function tristate ()
{
  eval x=\$$1
  case $x in
	i) flag="Install" ;;
	d) flag="Delete " ;;
	u) flag="Update " ;;
	*) flag="Nothing" ;;
  esac

  printf "%-4s %-4s %-26s %-26s" "'$1'" "'$flag" "| $3" "| $4'">> /tmp/MCmenu
  echo -e "

  function $1 () { l_tristate '$1' '$3' '$4' \"\$1\" ;}">> /tmp/MCradiolists
}

function l_tristate ()
{
  eval x=\$$1
  if [ ! "$2" == "-------" -a ! "$3" == "-------" ]
  then
	case $x in
		d) eval $1=  ;;
		u) eval $1=d ;;
		*) eval $1=u ;;
	esac
  elif [ ! "$2" == "-------" -a "$3" == "-------" ]
  then
	case $x in
		d) eval $1=  ;;
		*) eval $1=d ;;
	esac
  elif [ "$2" == "-------" -a ! "$3" == "-------" ]
  then
	case $x in
		i) eval $1=  ;;
		*) eval $1=i ;;
	esac
  else
	case $x in
		i) eval $1=d ;;
		d) eval $1=u ;;
		u) eval $1=  ;;
		*) eval $1=i ;;
	esac
  fi
}

function cleanup ()
{
  rm -f /tmp/MCmenu* /tmp/MCradiolists /tmp/MCdialog.out /tmp/help.out /tmp/tmp5.* /tmp/plugins.lst

  for plug in $PLUGINCOUNTER 99
  do
	eval SP$plug=
  done

  unset PLUGINCOUNTER
}

function plugin_install_call ()
{
  for plug in $PLUGINCOUNTER 99
  do
	eval x="$`echo P$plug`"

	if [ ! "$x" == "" ]
	then
		plugin_install_check "SP$plug" $x
	fi
  done
}

function plugin_install_check ()
{
  eval p=\$$1

  case $p in
     i) PluginInstall $2 $3 $4 $5 $6
	;;
     d) PluginDelete $2 $3
	;;
     u) PluginDelete $2 $3 ; PluginInstall $2 $3 $4 $5 $6
	if [ ! "$3" == "-------" ]
	then
		if [ "$2" == "---" ]
		then
			VV=$3
		else
			VV=$2
		fi
	fi
	;;
     *) if [ ! "$3" == "-------" ]
	then
		if [ "$2" == "---" ]
		then
			VV=$3
		else
			VV=$2
		fi
	fi
	;;
  esac
}

function PluginDelete ()
{
  rm -rf $PLGLIB/libvdr-$1.so.$VDRVERSION $PLGLIB/libvdr-$2.so.$VDRVERSION $PLGDIR/$1 $PLGDIR/$2> /dev/null 2>&1
}

function build_link ()
{
  Zx=$1
  LINKNAME=`echo "$Zx" | awk -F - '{print $1}'`
  LINKB=`echo "$LINKNAME" | wc -m`

  if [ ! "$LINKB" -le "4" ]
  then
	Zz=`echo $LINKNAME | sed -e 's/^...//'`
	LINKNAME=`echo $LINKNAME | sed -e 's/'${Zz}'//'`
  fi
}

function PluginInstall ()
{
  for x in $4
  do
	PACKAGE_SUFFIX=${x##*\.}
	cd $PKGDIR && rm -rf *.tar> /dev/null 2>&1

	case $PACKAGE_SUFFIX in
		(gz|GZ|tgz|TGZ) ORG_DIR=$(tar -tvzf $x | awk '{print $6}' | head -1)
				ORG_DIR=${ORG_DIR%%/*}
				tar -xvzf $x -C $PLGDIR> /dev/null 2>&1
				cd $PLGDIR && ln -s $ORG_DIR `echo $ORG_DIR | awk -F - '{print $1}'`
				;;
		(bz2)		bunzip2 -k $x
				PACKAGE_NAME=${x%.bz2}
				ORG_DIR=$(tar -tvf $PACKAGE_NAME | awk '{print $6}' | head -1)
				tar -xvf $PACKAGE_NAME -C $PLGDIR> /dev/null 2>&1
				cd $PLGDIR && ln -s $ORG_DIR `echo $ORG_DIR | awk -F - '{print $1}'`
	esac
  done

  if [[ -e $CMDP/$1.cmd && -e $PLGDIR/$1 ]]
  then
	cd $CMDP; chmod +x $1.cmd; ./$1.cmd
  fi
}

function activate_menu ()
{
  while true
  do
	comment_ctr=0

	menu_name

	for plug in $PLUGINCOUNTER 99
	do
		eval x="$`echo P$plug`"
		if [ ! "$x" == "" ]
		then
			tristate "SP$plug" $x
		fi
	done

	. /tmp/MCradiolists
	. /tmp/MCmenu 2>/tmp/MCdialog.out

	ret=$?

	read selection </tmp/MCdialog.out

	case "$ret" in
		0|3|4|5|6)	defaults="$selection $defaults"
				case "$ret" in
					0) eval $selection ;;
					3) eval $selection y ;;
					4) eval $selection n ;;
					5) eval $selection m ;;
					6) eval $selection c ;;
				esac

				default="${defaults%% *}" defaults="${defaults#* }"
				;;
			2)	$DIALOG --msgbox "No Help a.v." 5 78
				;;
		    255|1)	break
				;;
		      139)	stty sane; cleanup; exit 139
				;;
	esac
  done
}
  PluginVDRCheck | (dialog --gauge  "$2" 5 77 0)
  . /tmp/plugins.lst
  activate_menu
  plugin_install_call
  cleanup
}

  Geometry `stty size 2> /dev/null` && cd $PKGDIR && ls *> /tmp/tmp5.$$ && RunPluginsMgr

